diff --git a/src/tui/tools/bb-bead-crud.ts b/src/tui/tools/bb-bead-crud.ts
new file mode 100644
index 0000000..41b1ca3
--- /dev/null
+++ b/src/tui/tools/bb-bead-crud.ts
@@ -0,0 +1,318 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { execFileSync } from 'child_process';
+
+/**
+ * Bead CRUD tools that wrap the `bd` CLI.
+ * These allow the orchestrator and workers to create, update, and close beads.
+ */
+
+export function createBeadCrudTools(projectRoot: string): ToolDefinition[] {
+  return [
+    // bb_create - Create a new bead
+    {
+      name: 'bb_create',
+      label: 'Create Bead',
+      description: `Create a new bead (task/epic) for tracking work. Returns the bead ID.
+
+Examples:
+- Create a task: bb_create(title="Fix login bug", description="Users can't log in with SSO", type="task")
+- Create an epic: bb_create(title="User Profile Feature", type="epic", priority=1)
+- With labels: bb_create(title="Security audit", labels=["security", "urgent"])`,
+      parameters: Type.Object({
+        title: Type.String({ description: 'Bead title (concise summary)' }),
+        description: Type.Optional(Type.String({ description: 'Detailed description of the work' })),
+        type: Type.Optional(Type.String({ 
+          description: 'Bead type: task (default), epic, wisp, note',
+          default: 'task' 
+        })),
+        priority: Type.Optional(Type.Number({ 
+          description: 'Priority: 0 (urgent), 1 (high), 2 (medium), 3 (low). Default: 2' 
+        })),
+        labels: Type.Optional(Type.Array(Type.String(), { 
+          description: 'Labels to apply (e.g., ["bug", "frontend"])' 
+        })),
+        parent: Type.Optional(Type.String({ 
+          description: 'Parent bead ID if this is a child task' 
+        })),
+      }),
+      async execute(_toolCallId, params: unknown): Promise<any> {
+        const { title, description, type, priority, labels, parent } = params as {
+          title: string;
+          description?: string;
+          type?: string;
+          priority?: number;
+          labels?: string[];
+          parent?: string;
+        };
+
+        if (!title?.trim()) {
+          return {
+            content: [{ type: 'text', text: 'Title is required to create a bead.' }],
+            isError: true,
+          };
+        }
+
+        try {
+          const args = ['create', title];
+          
+          if (description) {
+            args.push('--description', description);
+          }
+          if (type) {
+            args.push('--type', type);
+          }
+          if (priority !== undefined) {
+            args.push('--priority', String(priority));
+          }
+          if (labels && labels.length > 0) {
+            args.push('--label', labels.join(','));
+          }
+          if (parent) {
+            args.push('--parent', parent);
+          }
+
+          const output = execFileSync('bd', args, {
+            cwd: projectRoot,
+            encoding: 'utf-8',
+            timeout: 10000,
+          });
+
+          // bd create outputs the bead ID
+          const beadId = output.trim().split('\n').pop()?.trim();
+
+          return {
+            content: [{ 
+              type: 'text', 
+              text: `✓ Created bead: ${beadId}
+
+Title: ${title}
+Type: ${type || 'task'}
+Priority: ${priority ?? 2}
+
+Use bb_update to add details or assign an agent. Use bb_spawn_worker to start work on this bead.` 
+            }],
+            details: { beadId, title, type: type || 'task' },
+          };
+        } catch (error) {
+          const message = error instanceof Error ? error.message : String(error);
+          return {
+            content: [{ type: 'text', text: `Failed to create bead: ${message}` }],
+            isError: true,
+          };
+        }
+      },
+    },
+
+    // bb_update - Update a bead
+    {
+      name: 'bb_update',
+      label: 'Update Bead',
+      description: `Update a bead's fields: status, assignee, notes, etc.
+
+Examples:
+- Claim a bead: bb_update(id="bead-001", status="in_progress", assignee="Engineer 01")
+- Add notes: bb_update(id="bead-001", notes="Found the bug in auth.ts line 42")
+- Mark blocked: bb_update(id="bead-001", status="blocked", notes="Waiting for API key")`,
+      parameters: Type.Object({
+        id: Type.String({ description: 'Bead ID to update' }),
+        status: Type.Optional(Type.String({ 
+          description: 'New status: open, in_progress, blocked, review, done, closed' 
+        })),
+        assignee: Type.Optional(Type.String({ 
+          description: 'Agent assigned to this bead (e.g., "Engineer 01")' 
+        })),
+        notes: Type.Optional(Type.String({ 
+          description: 'Notes to append to the bead (use for progress updates)' 
+        })),
+        priority: Type.Optional(Type.Number({ description: 'Update priority' })),
+        title: Type.Optional(Type.String({ description: 'Update title' })),
+        description: Type.Optional(Type.String({ description: 'Update description' })),
+      }),
+      async execute(_toolCallId, params: unknown): Promise<any> {
+        const { id, status, assignee, notes, priority, title, description } = params as {
+          id: string;
+          status?: string;
+          assignee?: string;
+          notes?: string;
+          priority?: number;
+          title?: string;
+          description?: string;
+        };
+
+        if (!id) {
+          return {
+            content: [{ type: 'text', text: 'Bead ID is required.' }],
+            isError: true,
+          };
+        }
+
+        try {
+          const args = ['update', id];
+          
+          if (status) {
+            args.push('--status', status);
+          }
+          if (assignee) {
+            args.push('--assignee', assignee);
+          }
+          if (notes) {
+            args.push('--notes', notes);
+          }
+          if (priority !== undefined) {
+            args.push('--priority', String(priority));
+          }
+          if (title) {
+            args.push('--title', title);
+          }
+          if (description) {
+            args.push('--description', description);
+          }
+
+          execFileSync('bd', args, {
+            cwd: projectRoot,
+            encoding: 'utf-8',
+            timeout: 10000,
+          });
+
+          const changes = [status && `status=${status}`, assignee && `assignee=${assignee}`, notes && 'notes added']
+            .filter(Boolean)
+            .join(', ');
+
+          return {
+            content: [{ 
+              type: 'text', 
+              text: `✓ Updated ${id}: ${changes || 'no changes'}` 
+            }],
+            details: { beadId: id, status, assignee },
+          };
+        } catch (error) {
+          const message = error instanceof Error ? error.message : String(error);
+          return {
+            content: [{ type: 'text', text: `Failed to update bead: ${message}` }],
+            isError: true,
+          };
+        }
+      },
+    },
+
+    // bb_close - Close a bead
+    {
+      name: 'bb_close',
+      label: 'Close Bead',
+      description: `Close a bead as completed or with a reason.
+
+Examples:
+- Complete: bb_close(id="bead-001", reason="Fixed the login bug by updating auth.ts")
+- Wontfix: bb_close(id="bead-002", reason="Not reproducible")`,
+      parameters: Type.Object({
+        id: Type.String({ description: 'Bead ID to close' }),
+        reason: Type.String({ description: 'Reason for closing (what was done or why wontfix)' }),
+      }),
+      async execute(_toolCallId, params: unknown): Promise<any> {
+        const { id, reason } = params as { id: string; reason: string };
+
+        if (!id || !reason) {
+          return {
+            content: [{ type: 'text', text: 'Both id and reason are required.' }],
+            isError: true,
+          };
+        }
+
+        try {
+          execFileSync('bd', ['close', id, '--reason', reason], {
+            cwd: projectRoot,
+            encoding: 'utf-8',
+            timeout: 10000,
+          });
+
+          return {
+            content: [{ 
+              type: 'text', 
+              text: `✓ Closed ${id}: ${reason}` 
+            }],
+            details: { beadId: id, reason },
+          };
+        } catch (error) {
+          const message = error instanceof Error ? error.message : String(error);
+          return {
+            content: [{ type: 'text', text: `Failed to close bead: ${message}` }],
+            isError: true,
+          };
+        }
+      },
+    },
+
+    // bb_show - Show bead details
+    {
+      name: 'bb_show',
+      label: 'Show Bead',
+      description: 'Get details about a specific bead including status, assignee, notes, and dependencies.',
+      parameters: Type.Object({
+        id: Type.String({ description: 'Bead ID to show' }),
+      }),
+      async execute(_toolCallId, params: unknown): Promise<any> {
+        const { id } = params as { id: string };
+
+        if (!id) {
+          return {
+            content: [{ type: 'text', text: 'Bead ID is required.' }],
+            isError: true,
+          };
+        }
+
+        try {
+          const output = execFileSync('bd', ['show', id], {
+            cwd: projectRoot,
+            encoding: 'utf-8',
+            timeout: 10000,
+          });
+
+          return {
+            content: [{ type: 'text', text: output }],
+            details: { beadId: id },
+          };
+        } catch (error) {
+          const message = error instanceof Error ? error.message : String(error);
+          return {
+            content: [{ type: 'text', text: `Failed to show bead: ${message}` }],
+            isError: true,
+          };
+        }
+      },
+    },
+
+    // bb_ready - List beads ready for work
+    {
+      name: 'bb_ready',
+      label: 'List Ready Beads',
+      description: 'List beads that are ready to be worked on (open status, no blockers).',
+      parameters: Type.Object({}),
+      async execute(_toolCallId, _params: unknown): Promise<any> {
+        try {
+          const output = execFileSync('bd', ['ready'], {
+            cwd: projectRoot,
+            encoding: 'utf-8',
+            timeout: 10000,
+          });
+
+          if (!output.trim()) {
+            return {
+              content: [{ type: 'text', text: 'No beads ready for work.' }],
+            };
+          }
+
+          return {
+            content: [{ type: 'text', text: `Ready beads:\n${output}` }],
+          };
+        } catch (error) {
+          const message = error instanceof Error ? error.message : String(error);
+          return {
+            content: [{ type: 'text', text: `Failed to list ready beads: ${message}` }],
+            isError: true,
+          };
+        }
+      },
+    },
+  ];
+}
diff --git a/src/tui/tools/bb-create-agent.ts b/src/tui/tools/bb-create-agent.ts
new file mode 100644
index 0000000..a3b57cc
--- /dev/null
+++ b/src/tui/tools/bb-create-agent.ts
@@ -0,0 +1,88 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { saveAgentType } from '../../lib/server/beads-fs';
+
+export function createCreateAgentTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_create_agent',
+    label: 'Create Agent Type',
+    description: 'Create a new agent type. Requires name, description, systemPrompt, and capabilities. The systemPrompt will be injected into workers spawned with this agent type.',
+    parameters: Type.Object({
+      name: Type.String({ description: 'Display name for the agent type (e.g., "Code Reviewer")' }),
+      description: Type.String({ description: 'What this agent type does (e.g., "Reviews code for quality and bugs")' }),
+      systemPrompt: Type.String({ description: 'System prompt injected into workers with this agent type. Define their focus and behavior.' }),
+      capabilities: Type.Array(Type.String(), { description: 'List of capabilities. Options: coding, implementation, planning, design_docs, review, arch_review, testing, research, debugging, ci_cd' }),
+      color: Type.Optional(Type.String({ description: 'Hex color for display (e.g., "#3b82f6"). Default: blue' })),
+    }),
+    async execute(_toolCallId, params: any) {
+      try {
+        const { name, description, systemPrompt, capabilities, color } = params;
+
+        // Validate required params
+        if (!name || typeof name !== 'string') {
+          return {
+            content: [{ type: 'text', text: 'Error: name is required and must be a string.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        if (!description || typeof description !== 'string') {
+          return {
+            content: [{ type: 'text', text: 'Error: description is required.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        if (!systemPrompt || typeof systemPrompt !== 'string') {
+          return {
+            content: [{ type: 'text', text: 'Error: systemPrompt is required.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        if (!Array.isArray(capabilities)) {
+          return {
+            content: [{ type: 'text', text: 'Error: capabilities must be an array of strings.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        const agentType = await saveAgentType({
+          name,
+          description,
+          systemPrompt,
+          capabilities,
+          color: color || '#3b82f6',
+          isBuiltIn: false,
+        });
+
+        return {
+          content: [{
+            type: 'text',
+            text: `Agent type created successfully!
+
+ID: ${agentType.id}
+Name: ${agentType.name}
+Description: ${agentType.description}
+Capabilities: ${agentType.capabilities.join(', ')}
+Color: ${agentType.color}
+
+Workers spawned with this agent type will receive the custom system prompt and tool access based on capabilities.`,
+          }],
+          details: { agentType },
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        return {
+          content: [{ type: 'text', text: `Failed to create agent type: ${message}` }],
+          isError: true,
+          details: { error: message },
+        };
+      }
+    },
+  };
+}
diff --git a/src/tui/tools/bb-create-archetype.ts b/src/tui/tools/bb-create-archetype.ts
new file mode 100644
index 0000000..117a110
--- /dev/null
+++ b/src/tui/tools/bb-create-archetype.ts
@@ -0,0 +1,88 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { saveArchetype } from '../../lib/server/beads-fs';
+
+export function createCreateArchetypeTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_create_archetype',
+    label: 'Create Archetype',
+    description: 'Create a new archetype. Requires name, description, systemPrompt, and capabilities. The systemPrompt will be injected into workers spawned with this archetype.',
+    parameters: Type.Object({
+      name: Type.String({ description: 'Display name for the archetype (e.g., "Code Reviewer")' }),
+      description: Type.String({ description: 'What this archetype does (e.g., "Reviews code for quality and bugs")' }),
+      systemPrompt: Type.String({ description: 'System prompt injected into workers with this archetype. Define their focus and behavior.' }),
+      capabilities: Type.Array(Type.String(), { description: 'List of capabilities. Options: coding, implementation, planning, design_docs, review, arch_review, testing, research' }),
+      color: Type.Optional(Type.String({ description: 'Hex color for display (e.g., "#3b82f6"). Default: blue' })),
+    }),
+    async execute(_toolCallId, params: any) {
+      try {
+        const { name, description, systemPrompt, capabilities, color } = params;
+
+        // Validate required params
+        if (!name || typeof name !== 'string') {
+          return {
+            content: [{ type: 'text', text: 'Error: name is required and must be a string.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        if (!description || typeof description !== 'string') {
+          return {
+            content: [{ type: 'text', text: 'Error: description is required.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        if (!systemPrompt || typeof systemPrompt !== 'string') {
+          return {
+            content: [{ type: 'text', text: 'Error: systemPrompt is required.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        if (!Array.isArray(capabilities)) {
+          return {
+            content: [{ type: 'text', text: 'Error: capabilities must be an array of strings.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        const archetype = await saveArchetype({
+          name,
+          description,
+          systemPrompt,
+          capabilities,
+          color: color || '#3b82f6',
+          isBuiltIn: false,
+        });
+
+        return {
+          content: [{
+            type: 'text',
+            text: `Archetype created successfully!
+
+ID: ${archetype.id}
+Name: ${archetype.name}
+Description: ${archetype.description}
+Capabilities: ${archetype.capabilities.join(', ')}
+Color: ${archetype.color}
+
+Workers spawned with this archetype will receive the custom system prompt and tool access based on capabilities.`,
+          }],
+          details: { archetype },
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        return {
+          content: [{ type: 'text', text: `Failed to create archetype: ${message}` }],
+          isError: true,
+          details: { error: message },
+        };
+      }
+    },
+  };
+}
diff --git a/src/tui/tools/bb-create-template.ts b/src/tui/tools/bb-create-template.ts
new file mode 100644
index 0000000..10195e6
--- /dev/null
+++ b/src/tui/tools/bb-create-template.ts
@@ -0,0 +1,106 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { saveTemplate, getArchetypes } from '../../lib/server/beads-fs';
+
+const TeamMemberSchema = Type.Object({
+  archetypeId: Type.String({ description: 'Archetype ID for this team member type' }),
+  count: Type.Number({ description: 'Number of workers with this archetype (minimum 1)' }),
+});
+
+export function createCreateTemplateTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_create_template',
+    label: 'Create Swarm Template',
+    description: 'Create a new swarm template. Defines team composition by specifying which archetypes and how many workers of each.',
+    parameters: Type.Object({
+      name: Type.String({ description: 'Display name for the template (e.g., "Full Stack Team")' }),
+      description: Type.String({ description: 'What this template is for (e.g., "General feature development with review")' }),
+      team: Type.Array(TeamMemberSchema, { description: 'Team composition. Each entry specifies an archetype ID and worker count.' }),
+      color: Type.Optional(Type.String({ description: 'Hex color for display. Default: amber' })),
+    }),
+    async execute(_toolCallId, params: any) {
+      try {
+        const { name, description, team, color } = params;
+
+        // Validate required params
+        if (!name || typeof name !== 'string') {
+          return {
+            content: [{ type: 'text', text: 'Error: name is required.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        if (!description || typeof description !== 'string') {
+          return {
+            content: [{ type: 'text', text: 'Error: description is required.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        if (!Array.isArray(team) || team.length === 0) {
+          return {
+            content: [{ type: 'text', text: 'Error: team must be a non-empty array.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        // Validate archetype IDs exist
+        const archetypes = await getArchetypes();
+        const validIds = new Set(archetypes.map(a => a.id));
+
+        for (const member of team) {
+          if (!validIds.has(member.archetypeId)) {
+            return {
+              content: [{ type: 'text', text: `Error: Unknown archetype "${member.archetypeId}". Valid archetypes: ${Array.from(validIds).join(', ')}` }],
+              isError: true,
+              details: {},
+            };
+          }
+          if (member.count < 1) {
+            return {
+              content: [{ type: 'text', text: `Error: count must be at least 1 for archetype "${member.archetypeId}".` }],
+              isError: true,
+              details: {},
+            };
+          }
+        }
+
+        const template = await saveTemplate({
+          name,
+          description,
+          team,
+          color: color || '#f59e0b',
+          isBuiltIn: false,
+        });
+
+        const teamDesc = team.map(m => `${m.count}x ${m.archetypeId}`).join(', ');
+
+        return {
+          content: [{
+            type: 'text',
+            text: `Swarm template created successfully!
+
+ID: ${template.id}
+Name: ${template.name}
+Description: ${template.description}
+Team: ${teamDesc}
+Color: ${template.color}
+
+Use this template when spawning swarms for coordinated multi-agent work.`,
+          }],
+          details: { template },
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        return {
+          content: [{ type: 'text', text: `Failed to create template: ${message}` }],
+          isError: true,
+          details: { error: message },
+        };
+      }
+    },
+  };
+}
diff --git a/src/tui/tools/bb-delete-agent.ts b/src/tui/tools/bb-delete-agent.ts
new file mode 100644
index 0000000..3294d11
--- /dev/null
+++ b/src/tui/tools/bb-delete-agent.ts
@@ -0,0 +1,56 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { deleteAgentType, getAgentTypes } from '../../lib/server/beads-fs';
+
+export function createDeleteAgentTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_delete_agent',
+    label: 'Delete Agent Type',
+    description: 'Delete an agent type. Built-in agent types cannot be deleted.',
+    parameters: Type.Object({
+      id: Type.String({ description: 'Agent type ID to delete' }),
+    }),
+    async execute(_toolCallId, params: any) {
+      try {
+        const { id } = params;
+
+        if (!id || typeof id !== 'string') {
+          return {
+            content: [{ type: 'text', text: 'Error: id is required.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        // Check if agent type exists
+        const agentTypes = await getAgentTypes(projectRoot);
+        const existing = agentTypes.find(a => a.id === id);
+
+        if (!existing) {
+          return {
+            content: [{ type: 'text', text: `Error: Agent type "${id}" not found.` }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        await deleteAgentType(id);
+
+        return {
+          content: [{
+            type: 'text',
+            text: `Agent type "${existing.name}" (${id}) deleted successfully.`,
+          }],
+          details: { deletedId: id },
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        return {
+          content: [{ type: 'text', text: `Failed to delete agent type: ${message}` }],
+          isError: true,
+          details: { error: message },
+        };
+      }
+    },
+  };
+}
diff --git a/src/tui/tools/bb-delete-archetype.ts b/src/tui/tools/bb-delete-archetype.ts
new file mode 100644
index 0000000..e752527
--- /dev/null
+++ b/src/tui/tools/bb-delete-archetype.ts
@@ -0,0 +1,64 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { deleteArchetype, getArchetypes } from '../../lib/server/beads-fs';
+
+export function createDeleteArchetypeTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_delete_archetype',
+    label: 'Delete Archetype',
+    description: 'Delete an archetype. Cannot delete built-in archetypes. Workers currently using this archetype will continue but new workers cannot be spawned with it.',
+    parameters: Type.Object({
+      id: Type.String({ description: 'Archetype ID to delete' }),
+    }),
+    async execute(_toolCallId, params: any) {
+      try {
+        const { id } = params;
+
+        if (!id || typeof id !== 'string') {
+          return {
+            content: [{ type: 'text', text: 'Error: id is required.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        // Check if it exists first for better error message
+        const archetypes = await getArchetypes();
+        const existing = archetypes.find(a => a.id === id);
+
+        if (!existing) {
+          return {
+            content: [{ type: 'text', text: `Error: Archetype "${id}" not found.` }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        if (existing.isBuiltIn) {
+          return {
+            content: [{ type: 'text', text: `Error: Cannot delete built-in archetype "${id}". Built-in archetypes are protected.` }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        await deleteArchetype(id);
+
+        return {
+          content: [{
+            type: 'text',
+            text: `Archetype "${id}" deleted successfully.`,
+          }],
+          details: { deletedId: id },
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        return {
+          content: [{ type: 'text', text: `Failed to delete archetype: ${message}` }],
+          isError: true,
+          details: { error: message },
+        };
+      }
+    },
+  };
+}
diff --git a/src/tui/tools/bb-delete-template.ts b/src/tui/tools/bb-delete-template.ts
new file mode 100644
index 0000000..81e7f66
--- /dev/null
+++ b/src/tui/tools/bb-delete-template.ts
@@ -0,0 +1,64 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { deleteTemplate, getTemplates } from '../../lib/server/beads-fs';
+
+export function createDeleteTemplateTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_delete_template',
+    label: 'Delete Swarm Template',
+    description: 'Delete a swarm template. Cannot delete built-in templates.',
+    parameters: Type.Object({
+      id: Type.String({ description: 'Template ID to delete' }),
+    }),
+    async execute(_toolCallId, params: any) {
+      try {
+        const { id } = params;
+
+        if (!id || typeof id !== 'string') {
+          return {
+            content: [{ type: 'text', text: 'Error: id is required.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        // Check if it exists first
+        const templates = await getTemplates();
+        const existing = templates.find(t => t.id === id);
+
+        if (!existing) {
+          return {
+            content: [{ type: 'text', text: `Error: Template "${id}" not found.` }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        if (existing.isBuiltIn) {
+          return {
+            content: [{ type: 'text', text: `Error: Cannot delete built-in template "${id}". Built-in templates are protected.` }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        await deleteTemplate(id);
+
+        return {
+          content: [{
+            type: 'text',
+            text: `Swarm template "${id}" deleted successfully.`,
+          }],
+          details: { deletedId: id },
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        return {
+          content: [{ type: 'text', text: `Failed to delete template: ${message}` }],
+          isError: true,
+          details: { error: message },
+        };
+      }
+    },
+  };
+}
diff --git a/src/tui/tools/bb-deviation.ts b/src/tui/tools/bb-deviation.ts
new file mode 100644
index 0000000..9f0075b
--- /dev/null
+++ b/src/tui/tools/bb-deviation.ts
@@ -0,0 +1,39 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { embeddedPiDaemon } from '../../lib/embedded-daemon';
+
+export function createDeviationTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_record_deviation',
+    label: 'Record Template Deviation',
+    description: 'Log when and why you are deviating from a standard mission template (e.g., adding an extra worker, skipping an archetype, changing the flow).',
+    parameters: Type.Object({
+      reason: Type.String({ description: 'Why the deviation was necessary' }),
+      deviation_type: Type.String({ description: 'What kind of deviation (e.g., "extra_worker", "missing_archetype", "custom_flow")' }),
+      details: Type.Optional(Type.String({ description: 'Additional context about the deviation' })),
+    }),
+    async execute(_toolCallId, params: any) {
+      try {
+        // We use the existing daemon event system to record this
+        embeddedPiDaemon.appendEvent(projectRoot, {
+          kind: 'deviation.proposed',
+          title: `Deviation [${params.deviation_type}]`,
+          detail: params.reason,
+          status: 'idle',
+        });
+
+        return {
+          content: [{ type: 'text', text: 'Deviation recorded successfully.' }],
+          details: {},
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        return {
+          content: [{ type: 'text', text: `Failed to record deviation: ${message}` }],
+          isError: true,
+          details: {},
+        };
+      }
+    },
+  };
+}
